abuild.in 29.8 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
74 75

	
Linux User's avatar
Linux User committed
76
set_xterm_title() {
77
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
97
	local i suggestion
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

111 112 113 114 115 116 117 118 119 120
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
121 122 123 124 125 126 127
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

128 129
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
130 131 132 133
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
134
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
135 136 137
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
138 139
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
140

141 142
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
143
			source_has $i || die "$i exists in md5sums but is missing in source"
144 145
		done
	fi
146

147 148 149
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
150 151

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
152 153

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
154 155 156 157
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
158
	local dummy f
159 160 161
	if [ -z "$source" ]; then
		return 0
	fi
162
	if [ -z "$md5sums" ]; then
163
		die "Use 'abuild checksum' to generate/update the checksum(s)"
164
	fi
165 166 167
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
168
	fetch || return 1
169
	msg "Checking md5sums..."
170
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
171 172
}

173 174 175 176 177 178 179 180 181 182
# verify upstream sources
sourcecheck() {
	local s
	for s in $source; do
		if is_remote $s; then
			wget -q -s $s || return 1
		fi
	done
}
	
Natanael Copa's avatar
Natanael Copa committed
183 184
uri_fetch() {
	local uri="$1"
185
	local d="${uri##*/}"	# $(basename $uri)
186 187 188 189
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

190 191 192 193 194
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
195
	esac
196 197 198 199 200

	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
201
	
Natanael Copa's avatar
Natanael Copa committed
202
	mkdir -p "$SRCDEST"
203 204 205
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
206
	fi
Linux User's avatar
Linux User committed
207
	msg "Fetching $uri"
208 209
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
210 211
}

212 213
is_remote() {
	case "$1" in
214
		http://*|ftp://*|https://*|saveas-*://*)
215 216 217 218 219
			return 0;;
	esac
	return 1
}

220 221 222 223 224
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
225 226 227 228 229
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
230 231 232 233
	fi
	uri_fetch "$uri"
}

234
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
235 236
	local s
	mkdir -p "$srcdir"
237 238
	for s in $source; do
		if is_remote "$s"; then
239
			uri_fetch_mirror "$s" || return 1
240 241 242 243
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
244 245 246
	done
}

247 248 249 250
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
251
# unpack the sources
252
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
253
	local u
254 255 256
	if [ -z "$force" ]; then
		md5check || return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
257 258 259 260
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
261
			*.tar.gz|*.tgz)
262
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
263 264
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
265
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
266
				tar -C "$srcdir" -jxf "$s" || return 1;;
267 268 269 270
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
271 272 273
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
274 275 276
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
277 278 279 280
		esac
	done
}

281 282 283 284
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
285 286
# cleanup source and package dir
clean() {
287
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
288
	rm -rf "$srcdir"
289
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
290 291 292 293 294 295
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
296 297 298 299
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
300 301 302 303 304
	done
}

cleanpkg() {
	local i
305
	getpkgver || return 1
306
	msg "Cleaning built packages..."
307
	for i in $pkgname $subpackages; do
308 309
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
310
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
311
	done
312
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
313 314
}

315 316 317
# clean all packages except current
cleanoldpkg() {
	local i j
318
	getpkgver || return 1
319 320 321 322 323 324 325 326 327
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
346 347
runpart() {
	local part=$1
348
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
349 350 351 352
	$part || die "$part failed"
}

# override those in your build script
353 354 355 356 357 358 359 360
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
361 362 363 364
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
365
build() {
366
	:
Natanael Copa's avatar
Natanael Copa committed
367 368
}

369 370 371 372 373 374
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

375 376 377 378 379 380 381 382 383
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

384
prepare_subpackages() {
385
	if [ -z "$subpackages" ]; then
386 387
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
388 389
	local i
	cd "$startdir"
390
	for i in $subpackages; do
391 392
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
393
		msg "Running split function $func..."
394
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
395
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
396 397 398
	done
}

399
prepare_metafiles() {
400
	getpkgver || return 1
401 402
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
403
	local dir=${subpkgdir:-$pkgdir}
404
	local pkg="$name-$pkgver-r$pkgrel.apk"
405
	local pkginfo="$controldir"/.PKGINFO
406
	local sub
Natanael Copa's avatar
Natanael Copa committed
407 408 409
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
410
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
411 412
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
413 414 415 416
	local parch="$CARCH"
	if [ "$arch" = "noarch" ]; then
		parch="noarch"
	fi
Natanael Copa's avatar
Natanael Copa committed
417

418
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
419
	if [ -n "$FAKEROOTKEY" ]; then
420
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
421
	fi
422 423
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
424
pkgname = $name
425
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
426 427 428 429 430
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
431
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
432
EOF
433 434
	local i deps
	deps="$depends"
435
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
436 437
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
438 439 440 441 442
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
443 444
	fi
	
Natanael Copa's avatar
Natanael Copa committed
445
	for i in $license; do
446
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
447 448
	done
	for i in $replaces; do
449
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
450
	done
451
	for i in $deps; do
452
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
453 454
	done
	for i in $conflicts; do
455
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
456 457
	done
	for i in $provides; do
458
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
459 460
	done
	for i in $backup; do
461
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
462
	done
Natanael Copa's avatar
Natanael Copa committed
463 464 465
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
466 467

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
468
	for i in $install ${triggers%%:*}; do
469 470
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
471
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
472 473
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
474
			*) 	error "$script: Invalid install/trigger script"
475 476 477
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
478
		cp "$startdir/$i" "$controldir/$script" || return 1
479
		chmod +x "$controldir/$script"
480 481
		metafiles="$metafiles $script"
	done
482
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
483
}
484

485 486 487
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
488
	# lets tell all the .so files this package provides in .provides-so
489 490
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
491 492 493 494 495
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
496
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
497 498 499
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
500 501
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
502
	done
Natanael Copa's avatar
Natanael Copa committed
503 504
}

505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
	else
		[ "$arch" = "noarch" ] && return 0
		error "No arch specific binaries found so arch should be set to \"noarch\""
		return 1
	fi
	return 0
}

532
prepare_package() {
533
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
534
	stripbin
535 536
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
537 538 539 540 541 542 543 544
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

568 569 570
trace_apk_deps() {
	local name="$1"
	local dir="$2"
571
	local i= j= found= autodeps= deppkgs= missing= so_paths=
572
	msg "Tracing dependencies for $name..."
573 574 575
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
576
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
577 578 579 580 581 582 583
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
	if grep -q -w '^libpthread.so.*' "$dir"/.needs-so 2>/dev/null \
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
584
		msg "  added libgcc (due to libpthread)"
585
	fi
586
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
587
		found=
588
		# first check if its provide by same apkbuild
589
		for j in "$dir"/../.control.*/.provides-so; do
590
			grep -w "$i" "$j" >/dev/null || continue
591
			found=${j%/.provides-so}
592
			found=${found##*/.control.}
593
			break
594
		done
595 596 597 598 599 600
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
601
		fi
602 603 604 605 606 607 608
	done

	# find all packages that holds the so files
	so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
	deppkgs=$($APK info -q -W $so_files) || return 1
	
	for found in $self_provided $deppkgs; do
609
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
610 611 612
			warning "You can remove '$found' from depends"
			continue
		fi
613 614
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
615
			msg "  added $found"
616
		fi
617
	done
618

619 620 621 622 623 624 625
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

626 627
create_apks() {
	local file
628
	getpkgver || return 1
629
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
630 631 632
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
633
		local apk=$name-$ver.apk
634
		local datadir="$pkgbasedir"/$name
635 636

		trace_apk_deps "$name" "$dir" || return 1
637
		msg "Creating $apk..."
638
		(
639 640
		cd "$datadir"
		# data.tar.gz
641 642 643 644 645 646
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
647 648 649 650 651 652

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
653
		cd "$dir"
654 655
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
656
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
657

658 659 660
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
661 662 663
	done
}

664
update_abuildrepo() {
665
	if ! apk_up2date || [ -n "$force" ]; then
666
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
667
			&& prepare && mkusers && rootpkg || return 1
668
	fi
669

670
	local apk
671 672
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
673 674 675 676 677 678 679 680 681

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
682
	for apk in $(listpkg); do
683
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
684 685
	done

686
	msg "Updating the cached abuild repository index..."
687 688 689 690 691
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
692
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
693 694
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
695 696 697
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
698
	chmod 644 APKINDEX.tar.gz
699 700
}

701
# predefined splitfunc doc
702
default_doc() {
703
	depends="$depends_doc"
704
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
705
	triggers="$triggers_doc"
706
	arch=${arch_doc:-"noarch"}
Natanael Copa's avatar
Natanael Copa committed
707
	local i
708
	for i in doc man info html sgml licenses gtk-doc; do
709 710 711
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
712 713
		fi
	done
714 715 716
	
	rm -f "$subpkgdir/usr/share/info/dir"

717 718 719
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
720 721 722 723

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
724
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
725 726 727
	return 0
}

728 729 730 731
doc() {
	default_doc
}

732
# predefined splitfunc mod
733
default_mod() {
734
	depends="$kernel $depends_mod"
735
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
736
	for i in firmware modules; do
737 738 739
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
740
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
741 742 743 744
		fi
	done
}

745 746 747 748
mod() {
	default_mod
}

749
# predefined splitfunc dev
750
default_dev() {
751
	local i= j=
752
	depends="$pkgname $depends_dev"
753
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
754
	triggers="$triggers_dev"
755 756 757 758
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
759
	cd "$pkgdir" || return 0
760 761
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
762
			usr/share/vala/vapi usr/share/gir-[0-9]*\
763 764 765
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
766 767
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
768
			mkdir -p "$d"
769
			mv "$pkgdir/$i" "$d"
770
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
771 772
		fi
	done
773 774 775 776 777 778 779
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
780
	return 0
Natanael Copa's avatar
Natanael Copa committed
781 782
}

783 784 785 786
dev() {
	default_dev
}

787 788 789 790
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
791 792
# build and package in fakeroot
rootpkg() {
793 794 795 796
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
797
		do_build=package
798
	fi
Natanael Copa's avatar
Natanael Copa committed
799
	cd "$startdir"
800
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
801
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
802 803
		prepare_subpackages \
		prepare_package \
804
		create_apks
Natanael Copa's avatar
Natanael Copa committed
805 806 807
}

srcpkg() {
808
	getpkgver || return 1
809
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
810
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
811 812 813 814 815
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
816
	msg "Creating source package $p.src.tar.gz..."
817
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
818 819
}

Natanael Copa's avatar
Natanael Copa committed
820 821
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
822
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
823 824
}

825
# check if package is up to date
826
apk_up2date() {
827
	getpkgver || return 1
828
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
829
	local i s
Natanael Copa's avatar
Natanael Copa committed
830
	cd "$startdir"
831 832 833 834 835
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

836
	for i in $source APKBUILD; do
837 838 839 840 841 842
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
843 844 845 846 847 848 849
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

850
abuildindex_up2date() {
851
	local i apk
852
	getpkgver || return 1
853 854
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
855
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
856 857 858 859 860
	done
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
861
	check_arch || return 0
862 863 864 865 866 867 868
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
869 870
}

871 872 873 874 875 876 877
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
878 879
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
880 881 882 883
		pkgname=
		subpackages=
		depends=
		makedepends=
884
		. $i
885
		dir=${i%/APKBUILD}
886
		deps=
887
		# filter out conflicts from deps and version info
888 889 890 891
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
892
			deps="$deps ${j%%[<>=]*}"
893
		done
894
		for j in $pkgname $subpackages; do
895
			echo "o ${j%%:*} $dir"
896
			set -- $deps
897 898 899 900 901 902 903
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
904 905
		done
	done
906
	)
907 908
}

909
deptrace() {
910 911 912
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
913
		deps="$deps ${i%%[<>=]*}"
914
	done
915
	[ -z "$deps" ] && return 0
916 917 918
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
919
			$APK info -q | sort |  sed 's/^/i /'
920
		fi
921
	) | awk -v pkgs="$deps" '
922 923 924 925 926 927 928 929 930 931 932 933 934 935 936 937 938 939 940 941 942 943 944 945 946

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
947
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
948
	local filtered_deps= conflicts=
949
	[ -n "$nodeps" ] && return 0
950
	msg "Analyzing dependencies..."
951

952 953 954
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
955
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
956 957
	done

958
	installed_deps=$($APK info -e $deps)
959
	# find which deps are missing
960
	for i in $deps; do
961
		if [ "${i#\!}" != "$i" ]; then
962
			$APK info -q -e "${i#\!}" \
963
				&& conflicts="$conflicts ${i#\!}"
964
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
965 966 967
			missing="$missing $i"
		fi
	done
968
	
969
	if [ -n "$conflicts" ]; then
970 971
		error "Conflicting package(s) installed:$conflicts"
		return 1
972 973 974 975 976 977 978 979
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
980

981
	uninstall_after=".makedepends-$pkgname $uninstall_after"
982
	if [ -n "$install_deps" ] && [ -z "$recursive" ] && [ -n "$deps" ]; then
983 984
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
985
		$SUDO $APK add --repository "$abuildrepo" \
986 987
			--wait 30 \
			--simulate --quiet $deps || return 1
988
		$SUDO $APK add --repository "$abuildrepo" \
989
			--wait 30 \
990 991
			--virtual .makedepends-$pkgname $deps \
			&& return 0
992
	fi
993 994
	
	[ -z "$recursive" ] && return 1
995 996 997

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
998
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
999
		if [ -z "$m" ]; then
1000 1001 1002
			missing="$missing $i"
		fi
	done
1003 1004
	
	for i in $(deptrace $missing); do
1005 1006 1007
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
1008 1009 1010 1011 1012 1013 1014 1015 1016 1017

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
1018
			$recursive $upgrade $color_opt abuildindex || return 1
1019
	done
1020
	$SUDO $APK add -u --repository "$abuildrepo" \
1021
		--wait 30 \
1022
		--virtual .makedepends-$pkgname $deps
1023 1024
}

1025
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
1026 1027
checksum() {
	local s files
1028
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
1029
	fetch
1030
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
1031 1032 1033 1034
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
1035 1036
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
1037 1038
}

1039
stripbin() {
1040
	local bin
1041 1042 1043
	if options_has "!strip" || [ "$arch" = "noarch" ]; then
		return 0
	fi
1044 1045
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
1046 1047 1048
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
1049 1050
}

1051 1052 1053
# simply list target apks
listpkg() {
	local i 
1054
	getpkgver || return 1
1055 1056 1057 1058 1059
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
1060 1061 1062 1063 1064 1065 1066 1067
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
1068 1069 1070 1071 1072 1073 1074 1075
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

1076 1077 1078 1079 1080 1081 1082 1083 1084 1085 1086
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

1087 1088 1089 1090 1091 1092
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
1093
		i=${i%%[<>=]*}
1094 1095 1096 1097 1098 1099
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

1100 1101 1102 1103
options_has() {
	list_has "$1" $options
}

1104
depends_has() {
1105
	deplist_has "$1" $depends
1106 1107
}

1108
makedepends_has() {
1109
	deplist_has "$1" $makedepends
1110 1111
}

Natanael Copa's avatar
Natanael Copa committed
1112 1113 1114 1115
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
1116 1117 1118 1119
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
Natanael Copa committed
1120 1121
# install package after build
post_add() {
1122
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1123 1124 1125 1126 1127 1128
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
Natanael Copa's avatar